/* StyleSwitcher.c generated by valac 0.56.17, the Vala compiler
 * generated from StyleSwitcher.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2021 Ryo Nakano <ryonakaknock3@gmail.com>
 * 
 * Some code inspired from elementary/switchboard-plug-pantheon-shell, src/Views/Appearance.vala
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <granite.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_STYLE_SWITCHER (style_switcher_get_type ())
#define STYLE_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE_SWITCHER, StyleSwitcher))
#define STYLE_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE_SWITCHER, StyleSwitcherClass))
#define IS_STYLE_SWITCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE_SWITCHER))
#define IS_STYLE_SWITCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE_SWITCHER))
#define STYLE_SWITCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE_SWITCHER, StyleSwitcherClass))

typedef struct _StyleSwitcher StyleSwitcher;
typedef struct _StyleSwitcherClass StyleSwitcherClass;
typedef struct _StyleSwitcherPrivate StyleSwitcherPrivate;
enum  {
	STYLE_SWITCHER_0_PROPERTY,
	STYLE_SWITCHER_NUM_PROPERTIES
};
static GParamSpec* style_switcher_properties[STYLE_SWITCHER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _StyleSwitcher {
	GtkBox parent_instance;
	StyleSwitcherPrivate * priv;
};

struct _StyleSwitcherClass {
	GtkBoxClass parent_class;
};

struct _StyleSwitcherPrivate {
	GtkSettings* gtk_settings;
	GraniteSettings* granite_settings;
	GraniteWidgetsModeButton* style_mode_button;
};

static gint StyleSwitcher_private_offset;
static gpointer style_switcher_parent_class = NULL;
VALA_EXTERN GSettings* application_settings;

VALA_EXTERN GType style_switcher_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (StyleSwitcher, g_object_unref)
VALA_EXTERN StyleSwitcher* style_switcher_new (void);
VALA_EXTERN StyleSwitcher* style_switcher_construct (GType object_type);
static void style_switcher_set_app_style (StyleSwitcher* self,
                                   gboolean is_prefer_dark,
                                   gboolean is_follow_system_style);
static void style_switcher_construct_app_style (StyleSwitcher* self);
static GObject * style_switcher_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _style_switcher___lambda22_ (StyleSwitcher* self);
static void __style_switcher___lambda22__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void _style_switcher___lambda23_ (StyleSwitcher* self);
static void __style_switcher___lambda23__g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self);
static void style_switcher_finalize (GObject * obj);
static GType style_switcher_get_type_once (void);

static inline gpointer
style_switcher_get_instance_private (StyleSwitcher* self)
{
	return G_STRUCT_MEMBER_P (self, StyleSwitcher_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

StyleSwitcher*
style_switcher_construct (GType object_type)
{
	StyleSwitcher * self = NULL;
	self = (StyleSwitcher*) g_object_new (object_type, "orientation", GTK_ORIENTATION_VERTICAL, "spacing", 6, NULL);
	return self;
}

StyleSwitcher*
style_switcher_new (void)
{
	return style_switcher_construct (TYPE_STYLE_SWITCHER);
}

static void
style_switcher_set_app_style (StyleSwitcher* self,
                              gboolean is_prefer_dark,
                              gboolean is_follow_system_style)
{
	GtkSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->gtk_settings;
	g_object_set (_tmp0_, "gtk-application-prefer-dark-theme", is_prefer_dark, NULL);
	_tmp1_ = application_settings;
	g_settings_set_boolean (_tmp1_, "is-prefer-dark", is_prefer_dark);
	_tmp2_ = application_settings;
	g_settings_set_boolean (_tmp2_, "is-follow-system-style", is_follow_system_style);
}

static void
style_switcher_construct_app_style (StyleSwitcher* self)
{
	GSettings* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = application_settings;
	if (g_settings_get_boolean (_tmp0_, "is-follow-system-style")) {
		GraniteSettings* _tmp1_;
		GraniteSettingsColorScheme _tmp2_;
		GraniteSettingsColorScheme _tmp3_;
		GraniteWidgetsModeButton* _tmp4_;
		_tmp1_ = self->priv->granite_settings;
		_tmp2_ = granite_settings_get_prefers_color_scheme (_tmp1_);
		_tmp3_ = _tmp2_;
		style_switcher_set_app_style (self, _tmp3_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, TRUE);
		_tmp4_ = self->priv->style_mode_button;
		granite_widgets_mode_button_set_selected (_tmp4_, 2);
	} else {
		gboolean is_prefer_dark = FALSE;
		GSettings* _tmp5_;
		_tmp5_ = application_settings;
		is_prefer_dark = g_settings_get_boolean (_tmp5_, "is-prefer-dark");
		style_switcher_set_app_style (self, is_prefer_dark, FALSE);
		if (is_prefer_dark) {
			GraniteWidgetsModeButton* _tmp6_;
			_tmp6_ = self->priv->style_mode_button;
			granite_widgets_mode_button_set_selected (_tmp6_, 1);
		} else {
			GraniteWidgetsModeButton* _tmp7_;
			_tmp7_ = self->priv->style_mode_button;
			granite_widgets_mode_button_set_selected (_tmp7_, 0);
		}
	}
}

static void
_style_switcher___lambda22_ (StyleSwitcher* self)
{
	style_switcher_construct_app_style (self);
}

static void
__style_switcher___lambda22__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
	_style_switcher___lambda22_ ((StyleSwitcher*) self);
}

static void
_style_switcher___lambda23_ (StyleSwitcher* self)
{
	GraniteWidgetsModeButton* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	_tmp0_ = self->priv->style_mode_button;
	_tmp1_ = granite_widgets_mode_button_get_selected (_tmp0_);
	_tmp2_ = _tmp1_;
	switch (_tmp2_) {
		case 0:
		{
			style_switcher_set_app_style (self, FALSE, FALSE);
			break;
		}
		case 1:
		{
			style_switcher_set_app_style (self, TRUE, FALSE);
			break;
		}
		case 2:
		{
			GraniteSettings* _tmp3_;
			GraniteSettingsColorScheme _tmp4_;
			GraniteSettingsColorScheme _tmp5_;
			_tmp3_ = self->priv->granite_settings;
			_tmp4_ = granite_settings_get_prefers_color_scheme (_tmp3_);
			_tmp5_ = _tmp4_;
			style_switcher_set_app_style (self, _tmp5_ == GRANITE_SETTINGS_COLOR_SCHEME_DARK, TRUE);
			break;
		}
		default:
		break;
	}
}

static void
__style_switcher___lambda23__g_object_notify (GObject* _sender,
                                              GParamSpec* pspec,
                                              gpointer self)
{
	_style_switcher___lambda23_ ((StyleSwitcher*) self);
}

static GObject *
style_switcher_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	StyleSwitcher * self;
	GtkLabel* style_label = NULL;
	GtkLabel* _tmp0_ = NULL;
	GtkImage* light_style_image = NULL;
	GtkImage* _tmp1_;
	GtkBox* light_style_box = NULL;
	gchar* _tmp2_;
	GtkBox* _tmp3_ = NULL;
	GtkBox* _tmp4_;
	GtkImage* _tmp5_;
	GtkBox* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkImage* dark_style_image = NULL;
	GtkImage* _tmp9_;
	GtkBox* dark_style_box = NULL;
	gchar* _tmp10_;
	GtkBox* _tmp11_ = NULL;
	GtkBox* _tmp12_;
	GtkImage* _tmp13_;
	GtkBox* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GraniteWidgetsModeButton* _tmp17_;
	GraniteWidgetsModeButton* _tmp18_;
	GtkBox* _tmp19_;
	GraniteWidgetsModeButton* _tmp20_;
	GtkBox* _tmp21_;
	GtkLabel* _tmp22_;
	GraniteWidgetsModeButton* _tmp23_;
	GtkImage* system_style_image = NULL;
	GtkImage* _tmp24_;
	GtkBox* system_style_box = NULL;
	gchar* _tmp25_;
	GtkBox* _tmp26_ = NULL;
	GtkBox* _tmp27_;
	GtkImage* _tmp28_;
	GtkBox* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GraniteWidgetsModeButton* _tmp32_;
	GtkBox* _tmp33_;
	GraniteSettings* _tmp34_;
	GraniteWidgetsModeButton* _tmp35_;
	parent_class = G_OBJECT_CLASS (style_switcher_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STYLE_SWITCHER, StyleSwitcher);
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Style:"));
	gtk_widget_set_halign ((GtkWidget*) _tmp0_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp0_);
	style_label = _tmp0_;
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("display-brightness-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp1_);
	light_style_image = _tmp1_;
	_tmp2_ = g_strdup (_ ("Light style"));
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	light_style_box = _tmp3_;
	_tmp4_ = light_style_box;
	_tmp5_ = light_style_image;
	gtk_container_add ((GtkContainer*) _tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = light_style_box;
	_tmp7_ = (GtkLabel*) gtk_label_new (_ ("Light"));
	g_object_ref_sink (_tmp7_);
	_tmp8_ = _tmp7_;
	gtk_container_add ((GtkContainer*) _tmp6_, (GtkWidget*) _tmp8_);
	_g_object_unref0 (_tmp8_);
	_tmp9_ = (GtkImage*) gtk_image_new_from_icon_name ("weather-clear-night-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp9_);
	dark_style_image = _tmp9_;
	_tmp10_ = g_strdup (_ ("Dark style"));
	_tmp11_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp11_, _tmp10_);
	_g_free0 (_tmp10_);
	g_object_ref_sink (_tmp11_);
	dark_style_box = _tmp11_;
	_tmp12_ = dark_style_box;
	_tmp13_ = dark_style_image;
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) _tmp13_);
	_tmp14_ = dark_style_box;
	_tmp15_ = (GtkLabel*) gtk_label_new (_ ("Dark"));
	g_object_ref_sink (_tmp15_);
	_tmp16_ = _tmp15_;
	gtk_container_add ((GtkContainer*) _tmp14_, (GtkWidget*) _tmp16_);
	_g_object_unref0 (_tmp16_);
	_tmp17_ = granite_widgets_mode_button_new ();
	g_object_ref_sink (_tmp17_);
	_g_object_unref0 (self->priv->style_mode_button);
	self->priv->style_mode_button = _tmp17_;
	_tmp18_ = self->priv->style_mode_button;
	_tmp19_ = light_style_box;
	granite_widgets_mode_button_append (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = self->priv->style_mode_button;
	_tmp21_ = dark_style_box;
	granite_widgets_mode_button_append (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = style_label;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp22_);
	_tmp23_ = self->priv->style_mode_button;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp23_);
	_tmp24_ = (GtkImage*) gtk_image_new_from_icon_name ("emblem-system-symbolic", (GtkIconSize) GTK_ICON_SIZE_BUTTON);
	g_object_ref_sink (_tmp24_);
	system_style_image = _tmp24_;
	_tmp25_ = g_strdup (_ ("Use the same style set in the system"));
	_tmp26_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp26_, _tmp25_);
	_g_free0 (_tmp25_);
	g_object_ref_sink (_tmp26_);
	system_style_box = _tmp26_;
	_tmp27_ = system_style_box;
	_tmp28_ = system_style_image;
	gtk_container_add ((GtkContainer*) _tmp27_, (GtkWidget*) _tmp28_);
	_tmp29_ = system_style_box;
	_tmp30_ = (GtkLabel*) gtk_label_new (_ ("System"));
	g_object_ref_sink (_tmp30_);
	_tmp31_ = _tmp30_;
	gtk_container_add ((GtkContainer*) _tmp29_, (GtkWidget*) _tmp31_);
	_g_object_unref0 (_tmp31_);
	_tmp32_ = self->priv->style_mode_button;
	_tmp33_ = system_style_box;
	granite_widgets_mode_button_append (_tmp32_, (GtkWidget*) _tmp33_);
	_tmp34_ = self->priv->granite_settings;
	g_signal_connect_object ((GObject*) _tmp34_, "notify::prefers-color-scheme", (GCallback) __style_switcher___lambda22__g_object_notify, self, 0);
	_tmp35_ = self->priv->style_mode_button;
	g_signal_connect_object ((GObject*) _tmp35_, "notify::selected", (GCallback) __style_switcher___lambda23__g_object_notify, self, 0);
	style_switcher_construct_app_style (self);
	_g_object_unref0 (system_style_box);
	_g_object_unref0 (system_style_image);
	_g_object_unref0 (dark_style_box);
	_g_object_unref0 (dark_style_image);
	_g_object_unref0 (light_style_box);
	_g_object_unref0 (light_style_image);
	_g_object_unref0 (style_label);
	return obj;
}

static void
style_switcher_class_init (StyleSwitcherClass * klass,
                           gpointer klass_data)
{
	style_switcher_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &StyleSwitcher_private_offset);
	G_OBJECT_CLASS (klass)->constructor = style_switcher_constructor;
	G_OBJECT_CLASS (klass)->finalize = style_switcher_finalize;
}

static void
style_switcher_instance_init (StyleSwitcher * self,
                              gpointer klass)
{
	GtkSettings* _tmp0_;
	GtkSettings* _tmp1_;
	GraniteSettings* _tmp2_;
	GraniteSettings* _tmp3_;
	self->priv = style_switcher_get_instance_private (self);
	_tmp0_ = gtk_settings_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	self->priv->gtk_settings = _tmp1_;
	_tmp2_ = granite_settings_get_default ();
	_tmp3_ = _g_object_ref0 (_tmp2_);
	self->priv->granite_settings = _tmp3_;
}

static void
style_switcher_finalize (GObject * obj)
{
	StyleSwitcher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STYLE_SWITCHER, StyleSwitcher);
	_g_object_unref0 (self->priv->gtk_settings);
	_g_object_unref0 (self->priv->granite_settings);
	_g_object_unref0 (self->priv->style_mode_button);
	G_OBJECT_CLASS (style_switcher_parent_class)->finalize (obj);
}

static GType
style_switcher_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StyleSwitcherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) style_switcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StyleSwitcher), 0, (GInstanceInitFunc) style_switcher_instance_init, NULL };
	GType style_switcher_type_id;
	style_switcher_type_id = g_type_register_static (gtk_box_get_type (), "StyleSwitcher", &g_define_type_info, 0);
	StyleSwitcher_private_offset = g_type_add_instance_private (style_switcher_type_id, sizeof (StyleSwitcherPrivate));
	return style_switcher_type_id;
}

GType
style_switcher_get_type (void)
{
	static volatile gsize style_switcher_type_id__once = 0;
	if (g_once_init_enter (&style_switcher_type_id__once)) {
		GType style_switcher_type_id;
		style_switcher_type_id = style_switcher_get_type_once ();
		g_once_init_leave (&style_switcher_type_id__once, style_switcher_type_id);
	}
	return style_switcher_type_id__once;
}

